=begin
(c) 2011 TIG
All Rights Reserved.
THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED 
WARRANTIES, INCLUDING,WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF 
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.

Plugins folder > OctaneOCMbatchExporter.rb

Usage:

Menu File > Octane OCM Batch Export... > Cameras
or Ruby Console type: OctaneOCMbatch::Camera.export
Only Scenes 'included' in the Animation in the 'Scene Manager' are exported.
To allow logical use of the scenes later keep names sequential - Scene001, 
Scene002 etc - never duplicate Scene names.
Available SKP Scenes are exported in turn into an OCM file, suitable to 
import into an Octane OCS later.  
Each OCM file is saved with the model inside a folder named after the model
thus - e.g. "../ModelName_BatchCameraOCMs/"
Each OCM file is named thus "../ModelName[Camera_SceneName].ocm".
Spaces and Non-ASCII characters are made into '_' in Model/Scene names.
It includes:-
eye [pos] [as xyz]
target [as xyz]
up [as xyz]
fov [degrees]

Menu File > Octane OCM Batch Export... > Suns
or Ruby Console type: OctaneOCMbatch::Sun.export
Only Scenes 'included' in the Animation in the 'Scene Manager' are exported.
To allow logical use of the scenes later keep names sequential - Scene001, 
Scene002 etc - never duplicate Scene names.
Available SKP Scenes are exported in turn into an OCM file, suitable to 
import into an Octane OCS later.  
Each OCM file is saved with the model inside a folder named after the model
thus - e.g. "../ModelName_BatchSunOCMs/"
Each OCM file is named thus "../ModelName[Sun_SceneName].ocm".
Spaces and Non-ASCII characters are made into '_' in Model/Scene names.
It includes:-
sundir [vector]
longitude [degrees]
latitude [degrees]
day [1-31]
month [1-12]
hour [0-24.000]
gmtoffset [0-24]
northoffset [0-1.0, i.e. North-angle as proportion of 360]

Donations:
by PayPal to info @ revitrev.org

Version:
1.0 20111011 First issue.
=end
###
require 'sketchup.rb'
###
module OctaneOCMbatch

class Camera

OCM='<?xml version=\'1.0\' encoding=\'utf-8\'?>
<OCS_1_0_23_Macro>
 <Node>
  <name>|NAME|</name>
  <typename>thinlens</typename>
  <id>2</id>
  <position>0.166 0.68</position>
  <inputnodepins>
   <NodePin>
    <typename>fov</typename>
    <id>0</id>
    <pintype>20001</pintype>
    <hasinternalnodegraph>true</hasinternalnodegraph>
    <basenodeid>1</basenodeid>
    <basenodepinid>0</basenodepinid>
    <internalnodegraph>
     <NodeGraph>
      <name>fov</name>
      <currentnewnodeid>2</currentnewnodeid>
      <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
      <nodes>
       <Node>
        <name>fov</name>
        <typename>float</typename>
        <id>1</id>
        <position>0 0</position>
        <parameters>
         <value>|FOV|</value>
         <minvalue>1</minvalue>
         <maxvalue>180</maxvalue>
         <usetextureui>false</usetextureui>
         <usetexturealphaui>false</usetexturealphaui>
         <isloglincapable>true</isloglincapable>
         <uselogscale>true</uselogscale>
         <modified>true</modified>
        </parameters>
        <inputnodepins>
        </inputnodepins>
       </Node>
      </nodes>
      <nodepinconnections>
      </nodepinconnections>
     </NodeGraph>
    </internalnodegraph>
   </NodePin>
   <NodePin>
    <typename>aperture</typename>
    <id>1</id>
    <pintype>20001</pintype>
    <hasinternalnodegraph>true</hasinternalnodegraph>
    <basenodeid>1</basenodeid>
    <basenodepinid>0</basenodepinid>
    <internalnodegraph>
     <NodeGraph>
      <name>aperture</name>
      <currentnewnodeid>2</currentnewnodeid>
      <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
      <nodes>
       <Node>
        <name>aperture</name>
        <typename>float</typename>
        <id>1</id>
        <position>0 0</position>
        <parameters>
         <value>1</value>
         <minvalue>0.01</minvalue>
         <maxvalue>100</maxvalue>
         <usetextureui>false</usetextureui>
         <usetexturealphaui>false</usetexturealphaui>
         <isloglincapable>true</isloglincapable>
         <uselogscale>true</uselogscale>
         <modified>false</modified>
        </parameters>
        <inputnodepins>
        </inputnodepins>
       </Node>
      </nodes>
      <nodepinconnections>
      </nodepinconnections>
     </NodeGraph>
    </internalnodegraph>
   </NodePin>
   <NodePin>
    <typename>pos</typename>
    <id>2</id>
    <pintype>20001</pintype>
    <hasinternalnodegraph>true</hasinternalnodegraph>
    <basenodeid>1</basenodeid>
    <basenodepinid>0</basenodepinid>
    <internalnodegraph>
     <NodeGraph>
      <name>pos</name>
      <currentnewnodeid>2</currentnewnodeid>
      <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
      <nodes>
       <Node>
        <name>pos</name>
        <typename>float3</typename>
        <id>1</id>
        <position>0 0</position>
        <parameters>
         <valuexyz>|POSXYZ|</valuexyz>
         <minvalue>-100000</minvalue>
         <maxvalue>100000</maxvalue>
         <modified>true</modified>
        </parameters>
        <inputnodepins>
        </inputnodepins>
       </Node>
      </nodes>
      <nodepinconnections>
      </nodepinconnections>
     </NodeGraph>
    </internalnodegraph>
   </NodePin>
   <NodePin>
    <typename>target</typename>
    <id>3</id>
    <pintype>20001</pintype>
    <hasinternalnodegraph>true</hasinternalnodegraph>
    <basenodeid>1</basenodeid>
    <basenodepinid>0</basenodepinid>
    <internalnodegraph>
     <NodeGraph>
      <name>target</name>
      <currentnewnodeid>2</currentnewnodeid>
      <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
      <nodes>
       <Node>
        <name>target</name>
        <typename>float3</typename>
        <id>1</id>
        <position>0 0</position>
        <parameters>
         <valuexyz>|TARGETXYZ|</valuexyz>
         <minvalue>-100000</minvalue>
         <maxvalue>100000</maxvalue>
         <modified>true</modified>
        </parameters>
        <inputnodepins>
        </inputnodepins>
       </Node>
      </nodes>
      <nodepinconnections>
      </nodepinconnections>
     </NodeGraph>
    </internalnodegraph>
   </NodePin>
   <NodePin>
    <typename>up</typename>
    <id>4</id>
    <pintype>20001</pintype>
    <hasinternalnodegraph>true</hasinternalnodegraph>
    <basenodeid>1</basenodeid>
    <basenodepinid>0</basenodepinid>
    <internalnodegraph>
     <NodeGraph>
      <name>up</name>
      <currentnewnodeid>2</currentnewnodeid>
      <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
      <nodes>
       <Node>
        <name>up</name>
        <typename>float3</typename>
        <id>1</id>
        <position>0 0</position>
        <parameters>
         <valuexyz>|UPXYZ|</valuexyz>
         <minvalue>-1</minvalue>
         <maxvalue>1</maxvalue>
         <modified>true</modified>
        </parameters>
        <inputnodepins>
        </inputnodepins>
       </Node>
      </nodes>
      <nodepinconnections>
      </nodepinconnections>
     </NodeGraph>
    </internalnodegraph>
   </NodePin>
   <NodePin>
    <typename>stereo</typename>
    <id>5</id>
    <pintype>20003</pintype>
    <hasinternalnodegraph>true</hasinternalnodegraph>
    <basenodeid>1</basenodeid>
    <basenodepinid>0</basenodepinid>
    <internalnodegraph>
     <NodeGraph>
      <name>stereo</name>
      <currentnewnodeid>2</currentnewnodeid>
      <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
      <nodes>
       <Node>
        <name>stereo</name>
        <typename>bool</typename>
        <id>1</id>
        <position>0 0</position>
        <parameters>
         <value>false</value>
         <modified>true</modified>
        </parameters>
        <inputnodepins>
        </inputnodepins>
       </Node>
      </nodes>
      <nodepinconnections>
      </nodepinconnections>
     </NodeGraph>
    </internalnodegraph>
   </NodePin>
   <NodePin>
    <typename>stereodist</typename>
    <id>6</id>
    <pintype>20001</pintype>
    <hasinternalnodegraph>true</hasinternalnodegraph>
    <basenodeid>1</basenodeid>
    <basenodepinid>0</basenodepinid>
    <internalnodegraph>
     <NodeGraph>
      <name>stereodist</name>
      <currentnewnodeid>2</currentnewnodeid>
      <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
      <nodes>
       <Node>
        <name>stereodist</name>
        <typename>float</typename>
        <id>1</id>
        <position>0 0</position>
        <parameters>
         <value>0.02</value>
         <minvalue>0.001</minvalue>
         <maxvalue>2</maxvalue>
         <usetextureui>false</usetextureui>
         <usetexturealphaui>false</usetexturealphaui>
         <isloglincapable>true</isloglincapable>
         <uselogscale>true</uselogscale>
         <modified>false</modified>
        </parameters>
        <inputnodepins>
        </inputnodepins>
       </Node>
      </nodes>
      <nodepinconnections>
      </nodepinconnections>
     </NodeGraph>
    </internalnodegraph>
   </NodePin>
   <NodePin>
    <typename>leftFilter</typename>
    <id>7</id>
    <pintype>20000</pintype>
    <hasinternalnodegraph>true</hasinternalnodegraph>
    <basenodeid>1</basenodeid>
    <basenodepinid>0</basenodepinid>
    <internalnodegraph>
     <NodeGraph>
      <name>leftFilter</name>
      <currentnewnodeid>2</currentnewnodeid>
      <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
      <nodes>
       <Node>
        <name>leftFilter</name>
        <typename>RGBspectrum</typename>
        <id>1</id>
        <position>0 0</position>
        <parameters>
         <rgbvalue>1 0 0.812</rgbvalue>
        </parameters>
        <inputnodepins>
        </inputnodepins>
       </Node>
      </nodes>
      <nodepinconnections>
      </nodepinconnections>
     </NodeGraph>
    </internalnodegraph>
   </NodePin>
   <NodePin>
    <typename>rightFilter</typename>
    <id>8</id>
    <pintype>20000</pintype>
    <hasinternalnodegraph>true</hasinternalnodegraph>
    <basenodeid>1</basenodeid>
    <basenodepinid>0</basenodepinid>
    <internalnodegraph>
     <NodeGraph>
      <name>rightFilter</name>
      <currentnewnodeid>2</currentnewnodeid>
      <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
      <nodes>
       <Node>
        <name>rightFilter</name>
        <typename>RGBspectrum</typename>
        <id>1</id>
        <position>0 0</position>
        <parameters>
         <rgbvalue>0 1 0.188</rgbvalue>
        </parameters>
        <inputnodepins>
        </inputnodepins>
       </Node>
      </nodes>
      <nodepinconnections>
      </nodepinconnections>
     </NodeGraph>
    </internalnodegraph>
   </NodePin>
   <NodePin>
    <typename>lensShift</typename>
    <id>9</id>
    <pintype>20001</pintype>
    <hasinternalnodegraph>true</hasinternalnodegraph>
    <basenodeid>1</basenodeid>
    <basenodepinid>0</basenodepinid>
    <internalnodegraph>
     <NodeGraph>
      <name>lensShift</name>
      <currentnewnodeid>2</currentnewnodeid>
      <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
      <nodes>
       <Node>
        <name>lensShift</name>
        <typename>float2</typename>
        <id>1</id>
        <position>0 0</position>
        <parameters>
         <valuexy>0 0</valuexy>
         <minvalue>-4</minvalue>
         <maxvalue>4</maxvalue>
         <modified>false</modified>
        </parameters>
        <inputnodepins>
        </inputnodepins>
       </Node>
      </nodes>
      <nodepinconnections>
      </nodepinconnections>
     </NodeGraph>
    </internalnodegraph>
   </NodePin>
  </inputnodepins>
 </Node>
</OCS_1_0_23_Macro>
'
  def Camera.export()
    @model=Sketchup.active_model
    mpath=@model.path
    if not mpath or mpath==""
      UI.messagebox("This 'Untitled' new Model must be Saved\nbefore Exporting !\nExiting... ")
      return nil
    end
    mpath=File.dirname(mpath)
    mname=@model.title.gsub(/[^A-Za-z0-9_-]/,'_')
    @pages=@model.pages
    ###
    if not @pages
      UI.messagebox("There are NO Scenes to Export !\nExiting... ")
      return nil
    end
    pages=[]
    @pages.each{|p|pages << p if p.name==p.label}
    if not pages
      UI.messagebox("There are NO Scenes set for Animation to Export !\nExiting... ")
      return nil
    end
    ###
    folder=File.join(mpath, mname+"_BatchCameraOCMs")
    Dir.mkdir(folder) if not File.exist?(folder)
    ###
   pages.each{|page|
    acc=page.camera
    view=page.name
    posa=acc.eye.to_a
    pos=[0,0,0]
    pos.x=posa.x.to_m.to_f
    pos.y=posa.z.to_m.to_f
    pos.z=posa.y.to_m.to_f * -1
    posxyz=pos.x.to_s+" "+pos.y.to_s+" "+pos.z.to_s
    targeta=acc.target.to_a
    target=[0,0,0]
    target.x=targeta.x.to_m.to_f
    target.y=targeta.z.to_m.to_f
    target.z=targeta.y.to_m.to_f * -1
    targetxyz=target.x.to_s+" "+target.y.to_s+" "+target.z.to_s
    upa=acc.up.normalize.to_a
    up=[0,0,0]
    up.x=upa.x.to_f
    up.y=upa.z.to_f
    up.z=upa.y.to_f * -1
    upxyz=up.x.to_s+" "+up.y.to_s+" "+up.z.to_s
    fol=acc.focal_length
    fovV=acc.fov
    wid=@model.active_view.vpwidth
    hei=@model.active_view.vpheight
    if acc.image_width != 0
      wid=acc.image_width
      if acc.aspect_ratio != 0
        aro=acc.aspect_ratio
      else
        aro=wid/hei
      end#if
      hei=wid/aro
    end#if
    h=2*fol*Math::tan(fovV.degrees/2)
    w=h*wid/hei
    fov=(2*Math::atan(w/(2*fol))).radians.to_s
    ###
    name="Camera_"+(view.gsub(/[^A-Za-z0-9_-]/,'_'))
    ### change values
    ocm=OCM
    ocm=ocm.gsub(/\|POSXYZ\|/,posxyz).gsub(/\|TARGETXYZ\|/,targetxyz).gsub(/\|UPXYZ\|/,upxyz).gsub(/\|FOV\|/,fov).gsub(/\|NAME\|/,name)
    ### write file
    ocmfile=File.join(folder, mname+"["+name+"].ocm").tr("\\","/")
    begin
      file=File.new(ocmfile,"w")
      file.puts(ocm)
      file.close
      #Sketchup.status_text="File:\n\n  "+ocmfile+"\n\nCompleted."
    rescue### trap if open
      UI.messagebox("File:\n\n  "+ocmfile+"\n\nCannot be written - it's probably already open.\nClose it and try making the Report again...\n\nExiting...")
	  return nil
    end
   }#pages
   #Sketchup.status_text=""
   UI.messagebox(pages.length.to_s+" OCM files added to\n"+folder)
  end#
  
end#class

##########

class Sun

OCM='<?xml version=\'1.0\' encoding=\'utf-8\'?>
<OCS_1_0_23_Macro>
 <Node>
  <name>|NAME|</name>
  <typename>daylight</typename>
  <id>7</id>
  <position>0.403 0.68</position>
  <inputnodepins>
   <NodePin>
    <typename>sundir</typename>
    <id>0</id>
    <pintype>20001</pintype>
    <hasinternalnodegraph>true</hasinternalnodegraph>
    <basenodeid>1</basenodeid>
    <basenodepinid>0</basenodepinid>
    <internalnodegraph>
     <NodeGraph>
      <name>sundir</name>
      <currentnewnodeid>2</currentnewnodeid>
      <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
      <nodes>
       <Node>
        <name>sundir</name>
        <typename>float3daylightsystem</typename>
        <id>1</id>
        <position>0 0</position>
        <parameters>
         <valuexyz>|SUNDIR|</valuexyz>
         <minvalue>-1</minvalue>
         <maxvalue>1</maxvalue>
         <modified>false</modified>
        </parameters>
        <inputnodepins>
         <NodePin>
          <typename>longitude</typename>
          <id>0</id>
          <pintype>20001</pintype>
          <hasinternalnodegraph>true</hasinternalnodegraph>
          <basenodeid>1</basenodeid>
          <basenodepinid>0</basenodepinid>
          <internalnodegraph>
           <NodeGraph>
            <name>longitude</name>
            <currentnewnodeid>2</currentnewnodeid>
            <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
            <nodes>
             <Node>
              <name>longitude</name>
              <typename>float</typename>
              <id>1</id>
              <position>0 0</position>
              <parameters>
               <value>|LONGITUDE|</value>
               <minvalue>-180</minvalue>
               <maxvalue>180</maxvalue>
               <usetextureui>false</usetextureui>
               <usetexturealphaui>false</usetexturealphaui>
               <isloglincapable>false</isloglincapable>
               <uselogscale>false</uselogscale>
               <modified>false</modified>
              </parameters>
              <inputnodepins>
              </inputnodepins>
             </Node>
            </nodes>
            <nodepinconnections>
            </nodepinconnections>
           </NodeGraph>
          </internalnodegraph>
         </NodePin>
         <NodePin>
          <typename>latitude</typename>
          <id>1</id>
          <pintype>20001</pintype>
          <hasinternalnodegraph>true</hasinternalnodegraph>
          <basenodeid>1</basenodeid>
          <basenodepinid>0</basenodepinid>
          <internalnodegraph>
           <NodeGraph>
            <name>latitude</name>
            <currentnewnodeid>2</currentnewnodeid>
            <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
            <nodes>
             <Node>
              <name>latitude</name>
              <typename>float</typename>
              <id>1</id>
              <position>0 0</position>
              <parameters>
               <value>|LATITUDE|</value>
               <minvalue>-90</minvalue>
               <maxvalue>90</maxvalue>
               <usetextureui>false</usetextureui>
               <usetexturealphaui>false</usetexturealphaui>
               <isloglincapable>false</isloglincapable>
               <uselogscale>false</uselogscale>
               <modified>false</modified>
              </parameters>
              <inputnodepins>
              </inputnodepins>
             </Node>
            </nodes>
            <nodepinconnections>
            </nodepinconnections>
           </NodeGraph>
          </internalnodegraph>
         </NodePin>
         <NodePin>
          <typename>day</typename>
          <id>2</id>
          <pintype>20002</pintype>
          <hasinternalnodegraph>true</hasinternalnodegraph>
          <basenodeid>1</basenodeid>
          <basenodepinid>0</basenodepinid>
          <internalnodegraph>
           <NodeGraph>
            <name>day</name>
            <currentnewnodeid>2</currentnewnodeid>
            <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
            <nodes>
             <Node>
              <name>day</name>
              <typename>int</typename>
              <id>1</id>
              <position>0 0</position>
              <parameters>
               <value>|DAY|</value>
               <minvalue>1</minvalue>
               <maxvalue>31</maxvalue>
               <isloglincapable>false</isloglincapable>
               <uselogscale>false</uselogscale>
               <modified>false</modified>
              </parameters>
              <inputnodepins>
              </inputnodepins>
             </Node>
            </nodes>
            <nodepinconnections>
            </nodepinconnections>
           </NodeGraph>
          </internalnodegraph>
         </NodePin>
         <NodePin>
          <typename>month</typename>
          <id>3</id>
          <pintype>20002</pintype>
          <hasinternalnodegraph>true</hasinternalnodegraph>
          <basenodeid>1</basenodeid>
          <basenodepinid>0</basenodepinid>
          <internalnodegraph>
           <NodeGraph>
            <name>month</name>
            <currentnewnodeid>2</currentnewnodeid>
            <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
            <nodes>
             <Node>
              <name>month</name>
              <typename>int</typename>
              <id>1</id>
              <position>0 0</position>
              <parameters>
               <value>|MONTH|</value>
               <minvalue>1</minvalue>
               <maxvalue>12</maxvalue>
               <isloglincapable>false</isloglincapable>
               <uselogscale>false</uselogscale>
               <modified>false</modified>
              </parameters>
              <inputnodepins>
              </inputnodepins>
             </Node>
            </nodes>
            <nodepinconnections>
            </nodepinconnections>
           </NodeGraph>
          </internalnodegraph>
         </NodePin>
         <NodePin>
          <typename>gmtoffset</typename>
          <id>4</id>
          <pintype>20002</pintype>
          <hasinternalnodegraph>true</hasinternalnodegraph>
          <basenodeid>1</basenodeid>
          <basenodepinid>0</basenodepinid>
          <internalnodegraph>
           <NodeGraph>
            <name>gmtoffset</name>
            <currentnewnodeid>2</currentnewnodeid>
            <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
            <nodes>
             <Node>
              <name>gmtoffset</name>
              <typename>int</typename>
              <id>1</id>
              <position>0 0</position>
              <parameters>
               <value>|GMTOFFSET|</value>
               <minvalue>-12</minvalue>
               <maxvalue>12</maxvalue>
               <isloglincapable>false</isloglincapable>
               <uselogscale>false</uselogscale>
               <modified>false</modified>
              </parameters>
              <inputnodepins>
              </inputnodepins>
             </Node>
            </nodes>
            <nodepinconnections>
            </nodepinconnections>
           </NodeGraph>
          </internalnodegraph>
         </NodePin>
         <NodePin>
          <typename>hour</typename>
          <id>5</id>
          <pintype>20001</pintype>
          <hasinternalnodegraph>true</hasinternalnodegraph>
          <basenodeid>1</basenodeid>
          <basenodepinid>0</basenodepinid>
          <internalnodegraph>
           <NodeGraph>
            <name>hour</name>
            <currentnewnodeid>2</currentnewnodeid>
            <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
            <nodes>
             <Node>
              <name>hour</name>
              <typename>float</typename>
              <id>1</id>
              <position>0 0</position>
              <parameters>
               <value>|HOUR|</value>
               <minvalue>0</minvalue>
               <maxvalue>24</maxvalue>
               <usetextureui>false</usetextureui>
               <usetexturealphaui>false</usetexturealphaui>
               <isloglincapable>false</isloglincapable>
               <uselogscale>false</uselogscale>
               <modified>false</modified>
              </parameters>
              <inputnodepins>
              </inputnodepins>
             </Node>
            </nodes>
            <nodepinconnections>
            </nodepinconnections>
           </NodeGraph>
          </internalnodegraph>
         </NodePin>
        </inputnodepins>
       </Node>
      </nodes>
      <nodepinconnections>
      </nodepinconnections>
     </NodeGraph>
    </internalnodegraph>
   </NodePin>
   <NodePin>
    <typename>turbidity</typename>
    <id>1</id>
    <pintype>20001</pintype>
    <hasinternalnodegraph>true</hasinternalnodegraph>
    <basenodeid>1</basenodeid>
    <basenodepinid>0</basenodepinid>
    <internalnodegraph>
     <NodeGraph>
      <name>turbidity</name>
      <currentnewnodeid>2</currentnewnodeid>
      <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
      <nodes>
       <Node>
        <name>turbidity</name>
        <typename>float</typename>
        <id>1</id>
        <position>0 0</position>
        <parameters>
         <value>2.2</value>
         <minvalue>0.5</minvalue>
         <maxvalue>16</maxvalue>
         <usetextureui>false</usetextureui>
         <usetexturealphaui>false</usetexturealphaui>
         <isloglincapable>true</isloglincapable>
         <uselogscale>true</uselogscale>
         <modified>false</modified>
        </parameters>
        <inputnodepins>
        </inputnodepins>
       </Node>
      </nodes>
      <nodepinconnections>
      </nodepinconnections>
     </NodeGraph>
    </internalnodegraph>
   </NodePin>
   <NodePin>
    <typename>power</typename>
    <id>2</id>
    <pintype>20001</pintype>
    <hasinternalnodegraph>true</hasinternalnodegraph>
    <basenodeid>1</basenodeid>
    <basenodepinid>0</basenodepinid>
    <internalnodegraph>
     <NodeGraph>
      <name>power</name>
      <currentnewnodeid>2</currentnewnodeid>
      <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
      <nodes>
       <Node>
        <name>power</name>
        <typename>float</typename>
        <id>1</id>
        <position>0 0</position>
        <parameters>
         <value>1</value>
         <minvalue>0.001</minvalue>
         <maxvalue>1000</maxvalue>
         <usetextureui>false</usetextureui>
         <usetexturealphaui>false</usetexturealphaui>
         <isloglincapable>true</isloglincapable>
         <uselogscale>true</uselogscale>
         <modified>false</modified>
        </parameters>
        <inputnodepins>
        </inputnodepins>
       </Node>
      </nodes>
      <nodepinconnections>
      </nodepinconnections>
     </NodeGraph>
    </internalnodegraph>
   </NodePin>
   <NodePin>
    <typename>northoffset</typename>
    <id>3</id>
    <pintype>20001</pintype>
    <hasinternalnodegraph>true</hasinternalnodegraph>
    <basenodeid>1</basenodeid>
    <basenodepinid>0</basenodepinid>
    <internalnodegraph>
     <NodeGraph>
      <name>northoffset</name>
      <currentnewnodeid>2</currentnewnodeid>
      <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
      <nodes>
       <Node>
        <name>northoffset</name>
        <typename>float</typename>
        <id>1</id>
        <position>0 0</position>
        <parameters>
         <value>|NORTHOFFSET|</value>
         <minvalue>-1</minvalue>
         <maxvalue>1</maxvalue>
         <usetextureui>false</usetextureui>
         <usetexturealphaui>false</usetexturealphaui>
         <isloglincapable>false</isloglincapable>
         <uselogscale>false</uselogscale>
         <modified>false</modified>
        </parameters>
        <inputnodepins>
        </inputnodepins>
       </Node>
      </nodes>
      <nodepinconnections>
      </nodepinconnections>
     </NodeGraph>
    </internalnodegraph>
   </NodePin>
  </inputnodepins>
 </Node>
</OCS_1_0_23_Macro>
'

  def Sun.export()
    @model=Sketchup.active_model
    mpath=@model.path
    if not mpath or mpath==""
      UI.messagebox("This 'Untitled' new Model must be Saved\nbefore Exporting !\nExiting... ")
      return nil
    end
    mpath=File.dirname(mpath)
    mname=@model.title.gsub(/[^A-Za-z0-9_-]/,'_')
    @pages=@model.pages
    ###
    if not @pages
      UI.messagebox("There are NO Scenes to Export !\nExiting... ")
      return nil
    end
    pages=[]
    @pages.each{|p|pages << p if p.name==p.label}
    if not pages
      UI.messagebox("There are NO Scenes set for Animation to Export !\nExiting... ")
      return nil
    end
    ###
    folder=File.join(mpath, mname+"_BatchSunOCMs")
    Dir.mkdir(folder) if not File.exist?(folder)
    ###
   pages.each{|scene|
    view=scene.name
    name="Sun_"+(view.gsub(/[^A-Za-z0-9_-]/,'_'))
      ###
      sunv=scene.shadow_info["SunDirection"]
      longitude=scene.shadow_info["Longitude"].to_s
      latitude=scene.shadow_info["Latitude"].to_s
      day=scene.shadow_info["ShadowTime"].day.to_s
      month=scene.shadow_info["ShadowTime"].month.to_s
      hour=(scene.shadow_info["ShadowTime"].hour+(scene.shadow_info["ShadowTime"].min/60.0)).to_s
      gmtoffset=scene.shadow_info["TZOffset"].to_s
      northoffset=(scene.shadow_info["NorthAngle"]/360.0).to_s
      ###
    suna=sunv.normalize.to_a
    sun=[0,0,0]
    sun.x=suna.x.to_f
    sun.y=suna.z.to_f
    sun.z=suna.y.to_f * -1
    sundir=sun.x.to_s+" "+sun.y.to_s+" "+sun.z.to_s
    ### change values
    ocm=OCM
    ocm=ocm.gsub(/\|NAME\|/,name).gsub(/\|SUNDIR\|/,sundir).gsub(/\|LONGITUDE\|/,longitude).gsub(/\|LATITUDE\|/,latitude).gsub(/\|DAY\|/,day).gsub(/\|MONTH\|/,month).gsub(/\|HOUR\|/,hour).gsub(/\|GMTOFFSET\|/,gmtoffset).gsub(/\|NORTHOFFSET\|/,northoffset)
    ### write file
    ocmfile=File.join(folder, mname+"["+name+"].ocm").tr("\\","/")
    begin
      file=File.new(ocmfile,"w")
      file.puts(ocm)
      file.close
      #Sketchup.status_text="File:\n\n  "+ocmfile+"\n\nCompleted."
    rescue### trap if open
      UI.messagebox("File:\n\n  "+ocmfile+"\n\nCannot be written - it's probably already open.\nClose it and try making the Report again...\n\nExiting...")
	  return nil
    end
   }#pages
   #Sketchup.status_text=""
   UI.messagebox(pages.length.to_s+" OCM files added to\n"+folder)
  end

end#class

###menu
if not file_loaded?(File.basename(__FILE__))
  menu=UI.menu("File").add_submenu("Octane OCM Batch Export...")
  menu.add_item("Cameras"){OctaneOCMbatch::Camera.export()}
  menu.add_item("Suns"){OctaneOCMbatch::Sun.export()}
end#if
file_loaded(File.basename(__FILE__))

end#module
###
